diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index e3dbe592..8f3b0de2 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -22,13 +22,14 @@ class SquadService extends Actor {
   private var memberToSquad : mutable.LongMap[Squad] = mutable.LongMap[Squad]()
   private var idToSquad : TrieMap[PlanetSideGUID, Squad] = new TrieMap[PlanetSideGUID, Squad]()
   private var idToSwitchboard : TrieMap[PlanetSideGUID, ActorRef] = new TrieMap[PlanetSideGUID, ActorRef]()
-  private var i : Int = 1
+  private var sid : Int = 1
   private val publishedLists : TrieMap[PlanetSideEmpire.Value, ListBuffer[SquadInfo]] = TrieMap[PlanetSideEmpire.Value, ListBuffer[SquadInfo]](
     PlanetSideEmpire.TR -> ListBuffer.empty,
     PlanetSideEmpire.NC -> ListBuffer.empty,
     PlanetSideEmpire.VS -> ListBuffer.empty
   )
-  private val bids : mutable.LongMap[PositionBid] = mutable.LongMap[PositionBid]()
+  private val invites : mutable.LongMap[Invitation] = mutable.LongMap[Invitation]()
+  private val queuedInvites : mutable.LongMap[List[Invitation]] = mutable.LongMap[List[Invitation]]()
   private val viewDetails : mutable.LongMap[PlanetSideGUID] = mutable.LongMap[PlanetSideGUID]()
 
   private [this] val log = org.log4s.getLogger
@@ -36,56 +37,70 @@ class SquadService extends Actor {
   override def preStart : Unit = {
     log.info("Starting...")
 
-    val testSquad = new Squad(PlanetSideGUID(3), PlanetSideEmpire.VS)
-    testSquad.Task = "\\#66CCFF Sentinels of Auraxis\\#FFFFFF ... \\#40FF40 Squad Up!!"
-    testSquad.ZoneId = 5
-    testSquad.Membership(0).Name = "Wizkid45"
-    testSquad.Membership(0).Role = "Fearless Leader"
-    testSquad.Membership(0).CharId = 30910985L
-    testSquad.Membership(0).ZoneId = 5
-    testSquad.Membership(0).Health = 64
-    testSquad.Membership(0).Armor = 34
-    testSquad.Membership(0).Position = Vector3(5526.5234f, 3818.7344f, 54.59375f)
-    testSquad.Membership(1).Name = "xoBLADEox"
-    testSquad.Membership(1).Role = "Right Hand"
-    testSquad.Membership(1).CharId = 42781919L
-    testSquad.Membership(1).ZoneId = 5
-    testSquad.Membership(1).Health = 54
-    testSquad.Membership(1).Armor = 44
-    testSquad.Membership(1).Position = Vector3(4673.5312f, 2604.8047f, 40.015625f)
-    testSquad.Membership(3).Name = "cabal0428"
-    testSquad.Membership(3).Role = "Left Hand"
-    testSquad.Membership(3).CharId = 353380L
-    testSquad.Membership(3).ZoneId = 5
-    testSquad.Membership(3).Health = 44
-    testSquad.Membership(3).Armor = 54
-    testSquad.Membership(3).Position = Vector3(4727.492f, 2613.5312f, 51.390625f)
-    testSquad.Membership(4).Name = "xSkiku"
-    testSquad.Membership(4).Role = "Right Foot's Middle Toe's Nail"
-    testSquad.Membership(4).CharId = 41588340L
-    testSquad.Membership(4).ZoneId = 5
-    testSquad.Membership(4).Health = 34
-    testSquad.Membership(4).Armor = 64
-    testSquad.Membership(4).Position = Vector3(3675.0f, 4789.8047f, 63.21875f)
-    idToSquad(PlanetSideGUID(3)) = testSquad
-    testSquad.Listed = true
-    UpdateSquadList(testSquad, None)
+//    val testSquad = new Squad(PlanetSideGUID(3), PlanetSideEmpire.VS)
+//    testSquad.Task = "\\#66CCFF Sentinels of Auraxis\\#FFFFFF ... \\#40FF40 Squad Up!!"
+//    testSquad.ZoneId = 5
+//    testSquad.Membership(0).Name = "Wizkid45"
+//    testSquad.Membership(0).Role = "Fearless Leader"
+//    testSquad.Membership(0).CharId = 30910985L
+//    testSquad.Membership(0).ZoneId = 5
+//    testSquad.Membership(0).Health = 64
+//    testSquad.Membership(0).Armor = 34
+//    testSquad.Membership(0).Position = Vector3(5526.5234f, 3818.7344f, 54.59375f)
+//    testSquad.Membership(1).Name = "xoBLADEox"
+//    testSquad.Membership(1).Role = "Right Hand"
+//    testSquad.Membership(1).CharId = 42781919L
+//    testSquad.Membership(1).ZoneId = 5
+//    testSquad.Membership(1).Health = 54
+//    testSquad.Membership(1).Armor = 44
+//    testSquad.Membership(1).Position = Vector3(4673.5312f, 2604.8047f, 40.015625f)
+//    testSquad.Membership(3).Name = "cabal0428"
+//    testSquad.Membership(3).Role = "Left Hand"
+//    testSquad.Membership(3).CharId = 353380L
+//    testSquad.Membership(3).ZoneId = 5
+//    testSquad.Membership(3).Health = 44
+//    testSquad.Membership(3).Armor = 54
+//    testSquad.Membership(3).Position = Vector3(4727.492f, 2613.5312f, 51.390625f)
+//    testSquad.Membership(4).Name = "xSkiku"
+//    testSquad.Membership(4).Role = "Right Foot's Middle Toe's Nail"
+//    testSquad.Membership(4).CharId = 41588340L
+//    testSquad.Membership(4).ZoneId = 5
+//    testSquad.Membership(4).Health = 34
+//    testSquad.Membership(4).Armor = 64
+//    testSquad.Membership(4).Position = Vector3(3675.0f, 4789.8047f, 63.21875f)
+//    idToSquad(PlanetSideGUID(3)) = testSquad
+//    testSquad.Listed = true
+//    UpdateSquadList(testSquad, None)
   }
 
   def GetNextSquadId() : PlanetSideGUID = {
-    val out = i
-    val j = i + 1
+    val out = sid
+    val j = sid + 1
     if(j == 65536) {
-      i = 1
+      sid = 1
     }
     else {
-      i = j
+      sid = j
     }
     PlanetSideGUID(out)
   }
 
+  def TryResetSquadId() : Boolean = {
+    if(idToSquad.isEmpty) {
+      sid = 1
+      true
+    }
+    else {
+      false
+    }
+  }
+
   def GetParticipatingSquad(player : Player) : Option[Squad] = {
-    memberToSquad.get(player.CharId) match {
+    GetParticipatingSquad(player.CharId)
+  }
+
+  def GetParticipatingSquad(charId : Long) : Option[Squad] = {
+    memberToSquad.get(charId) match {
       case opt @ Some(_) =>
         opt
       case None =>
@@ -114,24 +129,49 @@ class SquadService extends Actor {
     }
   }
 
-  def StartSquad(player : Player) : Squad = {
+  def GetLeadingSquad(charId : Long, opt : Option[Squad]) : Option[Squad] = {
+    opt.orElse(memberToSquad.get(charId)) match {
+      case Some(squad) =>
+        if(squad.Leader.CharId == charId) {
+          Some(squad)
+        }
+        else {
+          None
+        }
+      case _ =>
+        None
+    }
+  }
+
+  def CreateSquad(player : Player) : Squad = {
     val charId = player.CharId
     val faction = player.Faction
-    val id = GetNextSquadId()
     val name = player.Name
-    val squad = new Squad(id, faction)
+    val squad = new Squad(GetNextSquadId(), faction)
     val leadPosition = squad.Membership(squad.LeaderPositionIndex)
     leadPosition.Name = name
-    leadPosition.CharId = charId
+    leadPosition.CharId = player.CharId
     leadPosition.Health = player.Health
     leadPosition.Armor = player.Armor
     leadPosition.Position = player.Position
     leadPosition.ZoneId = 1
+    log.info(s"$name-$faction has started a new squad")
+    squad
+  }
+
+  def StartSquad(squad : Squad) : Squad = {
+    val charId = squad.Leader.CharId
+    val id = squad.GUID
     val switchboard = context.actorOf(Props[SquadSwitchboard], s"squad${id.guid}")
     memberToSquad += charId -> squad
     idToSquad += id -> squad
     idToSwitchboard += id -> switchboard
-    log.info(s"$name-$faction has started a new squad")
+    squad
+  }
+
+  def StartSquad(player : Player) : Squad = {
+    val squad = CreateSquad(player)
+    StartSquad(squad)
     squad
   }
 
@@ -199,137 +239,253 @@ class SquadService extends Actor {
     case Service.Leave(None) | Service.LeaveAll() => ;
 
     case SquadServiceMessage(tplayer, squad_action) => squad_action match {
-      case SquadAction.Membership(request_type, char_id, optional_char_id, _, _) => request_type match {
-        case SquadRequestType.Invite =>
-          //char_id is the inviter, e.g., the (prospective) squad leader
-          //this is just busy work; for actual joining operations, see SquadRequestType.Accept
-          (optional_char_id, memberToSquad.get(char_id)) match {
-            case (Some(invitee), Some(squad)) =>
-              bids(invitee) = VacancyBid(char_id, squad.GUID)
-              log.info(s"$invitee has been invited to squad ${squad.Task} by $char_id")
-              SquadEvents.publish( SquadServiceResponse(s"/$invitee/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, char_id, Some(invitee), tplayer.Name, false, Some(None))) )
-              SquadEvents.publish( SquadServiceResponse(s"/$char_id/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitee, Some(char_id), tplayer.Name, true, Some(None))) )
-            case (Some(invitee), None) =>
-              //the inviter does not currently belong to a squad; check for an existing placeholder, or create a new one
-              val ourSquad = {
-                bids.find { case (inviter, _) => inviter == char_id } match {
-                  case Some((_, SpontaneousBid(_, _squad))) =>
-                    _squad //borrow
-                  case _ =>
-                    val _squad = StartSquad(tplayer)
-                    memberToSquad.remove(char_id) //completely unlist until assured the squad is necessary
-                    _squad
-                }
-              }
-              bids(invitee) = SpontaneousBid(char_id, ourSquad)
-              SquadEvents.publish( SquadServiceResponse(s"/$invitee/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, char_id, Some(invitee), tplayer.Name, false, Some(None))) )
-              SquadEvents.publish( SquadServiceResponse(s"/$char_id/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitee, Some(char_id), tplayer.Name, true, Some(None))) )
-            case _ => ;
-          }
+      case SquadAction.Membership(SquadRequestType.Invite, invitingPlayer, Some(invitedPlayer), _, _) =>
+        //this is just busy work; for actual joining operations, see SquadRequestType.Accept
+//        FindBid(invitingPlayer, invitedPlayer) match {
+//          case Some(bid) =>
+//            //invitingPlayer and invitedPlayer have both tried to join each others's squads
+//            //treat this junction as consent
+//            self ! SquadServiceMessage(tplayer, SquadAction.Membership(SquadRequestType.Accept, invitingPlayer, Some(invitedPlayer), "", None))
+//          case _ => ;
+//        }
+        (memberToSquad.get(invitingPlayer), memberToSquad.get(invitedPlayer)) match {
+          case (Some(squad1), Some(squad2)) =>
+            //both players are in squads
+            if(squad1.GUID == squad2.GUID) {
+              //both players are in the same squad; no need to do anything
+            }
+            else {
+              //we might do some platoon chicanery with this case later
+              //TODO platoons
+            }
 
-        case SquadRequestType.Accept =>
-          //char_id is the invitee, e.g., the person joining the squad
-          bids.remove(char_id) match {
-            case Some(NormalBid(_/*inviterCharId*/, squadGUID, line)) if idToSquad.get(squadGUID).nonEmpty =>
-              //player requested to join a squad's specific position
-              JoinSquad(tplayer, idToSquad(squadGUID), line)
+          case (Some(squad), None) =>
+            //the classic situation
+            log.info(s"$invitedPlayer has been invited to squad ${squad.Task} by $invitingPlayer")
+            val leader = squad.Leader
+            val leaderCharId = leader.CharId
+            val bid = VacancyInvite(leaderCharId, leader.Name, squad.GUID)
+            AddInvite(invitedPlayer, bid) match {
+              case out @ Some(_) if out.contains(bid) =>
+                SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, leaderCharId, Some(invitedPlayer), tplayer.Name, false, Some(None))))
+                SquadEvents.publish(SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(leaderCharId), tplayer.Name, true, Some(None))))
+              case Some(_) =>
+                SquadEvents.publish(SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(leaderCharId), tplayer.Name, true, Some(None))))
+              case _ => ;
+            }
 
-            case Some(VacancyBid(inviterCharId, squadGUID)) if idToSquad.get(squadGUID).nonEmpty =>
-              //we were invited by the squad leader into an existing squad
-              val squad = idToSquad(squadGUID)
+          case (None, Some(squad)) =>
+            //flip around the roles - the inviting becomes the invited
+            //TODO needs work
+            log.info(s"$invitedPlayer has asked $invitingPlayer for an invition to squad ${squad.Task}")
+            val bid = VacancyInvite(invitedPlayer, "", squad.GUID)
+            AddInvite(invitingPlayer, bid) match {
+              case out @ Some(_) if out.contains(bid) =>
+                SquadEvents.publish(SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(invitingPlayer), tplayer.Name, false, Some(None))))
+                SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitingPlayer, Some(invitedPlayer), tplayer.Name, true, Some(None))))
+              case Some(_) =>
+                SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitingPlayer, Some(invitedPlayer), tplayer.Name, true, Some(None))))
+              case _ => ;
+            }
+
+          case (None, None) =>
+            //neither the invited player nor the inviting player belong to any squad
+            log.info(s"$invitedPlayer has been invited to join $invitingPlayer's spontaneous squad")
+            val bid = SpontaneousInvite(tplayer)
+            AddInvite(invitedPlayer, bid) match {
+              case out @ Some(_) if out.contains(bid) =>
+                SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitingPlayer, Some(invitedPlayer), tplayer.Name, false, Some(None))))
+                SquadEvents.publish(SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(invitingPlayer), tplayer.Name, true, Some(None))))
+              case Some(_) =>
+                SquadEvents.publish(SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, invitedPlayer, Some(invitingPlayer), tplayer.Name, true, Some(None))))
+              case _ => ;
+            }
+
+          case _ => ;
+        }
+
+      case SquadAction.Membership(SquadRequestType.Accept, invitedPlayer, _, _, _) =>
+        val acceptedInvite = RemoveInvite(invitedPlayer)
+        acceptedInvite match {
+          case Some(BidForPosition(petitioner, guid, position)) if idToSquad.get(guid).nonEmpty =>
+            //player requested to join a squad's specific position
+            //invitedPlayer is actually the squad leader; petitioner is the actual "invitedPlayer"
+            if(memberToSquad.get(petitioner.CharId).isEmpty) {
+              JoinSquad(petitioner, idToSquad(guid), position)
+            }
+            else {
+              log.warn("Accept -> Bid: the invited player is already a member of a squad and can not join a second one")
+            }
+
+          case Some(VacancyInvite(invitingPlayer, _, guid))
+            if idToSquad.get(guid).nonEmpty =>
+            //we were invited by the squad leader into an existing squad
+            if(memberToSquad.get(invitedPlayer).isEmpty) {
+              val squad = idToSquad(guid)
               squad.Membership.zipWithIndex.find({ case (member, index) =>
                 ValidOpenSquadPosition(squad, index, member, tplayer.Certifications)
               }) match {
                 case Some((_, line)) =>
-                  SquadEvents.publish( SquadServiceResponse(s"/$inviterCharId/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, inviterCharId, Some(char_id), tplayer.Name, false, Some(None))) )
-                  SquadEvents.publish( SquadServiceResponse(s"/$char_id/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, char_id, Some(inviterCharId), "", true, Some(None))) )
+                  SquadEvents.publish(SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayer, Some(invitedPlayer), tplayer.Name, false, Some(None))))
+                  SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayer), "", true, Some(None))))
                   JoinSquad(tplayer, squad, line)
+                  RemoveQueuedInvites(invitedPlayer) //TODO deal with these somehow
                 case _ => ;
               }
+            }
+            else {
+              log.warn("Accept -> Invite: the invited player is already a member of a squad and can not join a second one")
+            }
 
-            case Some(SpontaneousBid(inviterCharId, placeholderSquad)) =>
-              //we were invited by someone into a new squad they would form
-              (GetParticipatingSquad(tplayer) match {
-                case Some(participating) =>
-                  if(participating.Leader.CharId == inviterCharId) {
-                    Some(participating)
+          case Some(SpontaneousInvite(invitingPlayer)) =>
+            //we were invited by someone into a new squad they would form
+            val invitingPlayerCharId = invitingPlayer.CharId
+            (GetParticipatingSquad(invitingPlayer) match {
+              case Some(participating) =>
+                if(participating.Leader.CharId == invitingPlayerCharId) {
+                  Some(participating)
+                }
+                else {
+                  //inviter joined a squad and is not its leader; bounce this request off of the squad leader
+                  participating.Membership.zipWithIndex.find({ case (member, index) =>
+                    ValidOpenSquadPosition(participating, index, member, tplayer.Certifications)
+                  }) match {
+                    case Some((_, line)) =>
+                      val bid = BidForPosition(tplayer, participating.GUID, line)
+                      AddInvite(participating.Leader.CharId, bid) match {
+                        case out @ Some(_) if out.contains(bid) =>
+                          HandleBidForPosition(bid, tplayer)
+                        case _ => ;
+                      }
+                    case _ => ;
                   }
-                  else {
-                    //inviter joined a squad and is not its leader; bounce this request off of the squad leader
-                    //TODO squad leader receives "<player> wants to join squad" prompt
-                    val leaderCharId = participating.Leader.CharId
-                    bids(char_id) = VacancyBid(leaderCharId, participating.GUID) //reframed request
-                    SquadEvents.publish(SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.Invite(char_id, leaderCharId, tplayer.Name)))
-                    None
-                  }
-                case None =>
-                  placeholderSquad.Task = s"${tplayer.Name}'s Squad"
-                  memberToSquad(inviterCharId) = placeholderSquad
-                  SquadEvents.publish(SquadServiceResponse(s"/$inviterCharId/Squad", SquadResponse.InitSquad(placeholderSquad.GUID)))
-                  Some(placeholderSquad)
-              }) match {
+                  None
+                }
+              case None =>
+                val squad = StartSquad(invitingPlayer)
+                squad.Task = s"${tplayer.Name}'s Squad"
+                SquadEvents.publish(SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.InitSquad(squad.GUID)))
+                Some(squad)
+            }) match {
               case Some(squad) =>
                 squad.Membership.zipWithIndex.find({ case (member, index) =>
                   ValidOpenSquadPosition(squad, index, member, tplayer.Certifications)
                 }) match {
                   case Some((_, line)) =>
-                    SquadEvents.publish( SquadServiceResponse(s"/$inviterCharId/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, inviterCharId, Some(char_id), tplayer.Name, false, Some(None))) )
-                    SquadEvents.publish( SquadServiceResponse(s"/$char_id/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, char_id, Some(inviterCharId), "", true, Some(None))) )
+                    SquadEvents.publish( SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayerCharId), "", true, Some(None))) )
                     JoinSquad(tplayer, squad, line)
+                    SquadEvents.publish( SquadServiceResponse(s"/$invitingPlayerCharId/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayerCharId, Some(invitedPlayer), tplayer.Name, false, Some(None))) )
+                    RemoveQueuedInvites(invitedPlayer) //TODO deal with these somehow
                   case _ => ;
                 }
               case None => ;
-              }
-
-            case _ => ;
-          }
-
-        case SquadRequestType.Leave =>
-          //char_id is the player leaving
-          val squad = memberToSquad(char_id)
-          val leader = squad.Leader.CharId
-          if(char_id == leader) {
-            //squad leader is leaving his own squad, so it will be disbanded
-            squad.Membership
-              .filterNot { _.CharId == leader }
-              .foreach { member =>
-                val charId = member.CharId
-                SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Disband, 0, 0, charId, None, "", false, Some(None))))
-              }
-            CloseOutSquad(squad)
-            SquadEvents.publish(SquadServiceResponse(s"/$leader/Squad", SquadResponse.Membership(SquadResponseType.Disband, 0, 0, leader, None, "", true, Some(None))))
-          }
-          else {
-            if(optional_char_id.contains(char_id)) {
-              //leaving the squad of our own accord
-              LeaveSquad(tplayer, squad)
             }
-            else if(optional_char_id.contains(leader)) {
-              //kicked by the squad leader
-              SquadEvents.publish( SquadServiceResponse(s"/$char_id/Squad", SquadResponse.Membership(SquadResponseType.Leave, 0, 0, char_id, Some(leader), tplayer.Name, false, Some(None))) )
-              SquadEvents.publish( SquadServiceResponse(s"/$leader/Squad", SquadResponse.Membership(SquadResponseType.Leave, 0, 0, leader, Some(char_id), "", true, Some(None))) )
-              LeaveSquad(tplayer, squad)
+
+          case None =>
+            //the invite either timed-out or was withdrawn; select a new one?
+            NextInvite(invitedPlayer) match {
+              case Some(bid : BidForPosition) if !acceptedInvite.contains(bid) =>
+                HandleBidForPosition(bid, tplayer)
+              case Some(bid) if !acceptedInvite.contains(bid) =>
+                SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, bid.InviterCharId, Some(invitedPlayer), bid.InviterName, false, Some(None))))
+              case None => ;
             }
-          }
+        }
 
-        case SquadRequestType.Reject =>
-          //a player has opted out of joining a squad
-          (bids.remove(char_id) match {
-            case Some(SpontaneousBid(inviterCharId, squad)) if squad.Leader.CharId != char_id =>
-              (inviterCharId, squad)
-            case Some(VacancyBid(inviterCharId, guid)) if idToSquad(guid).Leader.CharId != char_id =>
-              (inviterCharId, idToSquad.get(guid))
-            case _ => ;
-              (0L, None)
-          }) match {
-            case (inviterCharId, Some(squad)) =>
-              SquadEvents.publish( SquadServiceResponse(s"/$inviterCharId/Squad", SquadResponse.Membership(SquadResponseType.Reject, 0, 0, inviterCharId, Some(char_id), tplayer.Name, false, Some(None))) )
-              SquadEvents.publish( SquadServiceResponse(s"/$char_id/Squad", SquadResponse.Membership(SquadResponseType.Reject, 0, 0, char_id, Some(inviterCharId), "", true, Some(None))) )
-            case _ => ;
+      case SquadAction.Membership(SquadRequestType.Leave, leavingPlayer, optionalPlayer, _, _) =>
+        val squad = memberToSquad(leavingPlayer)
+        val leader = squad.Leader.CharId
+        if(leavingPlayer == leader || squad.Size == 2) {
+          //squad leader is leaving his own squad, so it will be disbanded
+          //alternately, squad is only composed of two people, so it will be closed-out when one of them leaves
+          val membership = squad.Membership.collect { case member if member.CharId > 0 => member.CharId }
+          membership.foreach { charId =>
+            SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Leave, 0, 0, charId, None, "", false, Some(None))))
           }
+          CloseOutSquad(squad)
+          SquadEvents.publish(SquadServiceResponse(s"/$leader/Squad", SquadResponse.Membership(SquadResponseType.Disband, 0, 0, leader, None, "", true, Some(None))))
+          membership
+            .filterNot(_ == leader)
+            .foreach { charId =>
+            SquadEvents.publish(SquadServiceResponse(s"/$charId/Squad", SquadResponse.Membership(SquadResponseType.Disband, 0, 0, charId, None, "", false, Some(None))))
+          }
+          SquadEvents.publish( SquadServiceResponse(s"/$leader/Squad", SquadResponse.InitSquad(PlanetSideGUID(0))) )
+          SquadEvents.publish( SquadServiceResponse(s"/$leader/Squad", SquadResponse.Detail(PlanetSideGUID(0), SquadDetail().Complete)) )
+        }
+        else {
+          if(optionalPlayer.contains(leavingPlayer)) {
+            //leaving the squad of own accord
+            LeaveSquad(tplayer, squad)
+          }
+          else if(optionalPlayer.contains(leader)) {
+            //kicked by the squad leader
+            SquadEvents.publish( SquadServiceResponse(s"/$leavingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Leave, 0, 0, leavingPlayer, Some(leader), tplayer.Name, false, Some(None))) )
+            SquadEvents.publish( SquadServiceResponse(s"/$leader/Squad", SquadResponse.Membership(SquadResponseType.Leave, 0, 0, leader, Some(leavingPlayer), "", true, Some(None))) )
+            LeaveSquad(tplayer, squad)
+          }
+        }
 
-        case _ => ;
-      }
+      case SquadAction.Membership(SquadRequestType.Reject, rejectingPlayer, optionalPlayer, _, _) =>
+        val rejectedBid = RemoveInvite(rejectingPlayer)
+        //(A, B) -> person who made the rejection, person who was rejected
+        (rejectedBid match {
+          case Some(SpontaneousInvite(invitingPlayer)) =>
+            //rejectingPlayer is the would-be squad member
+            (Some(rejectingPlayer), Some(invitingPlayer.CharId))
+          case Some(VacancyInvite(invitingPlayer, _, guid)) if idToSquad(guid).Leader.CharId != rejectingPlayer =>
+            //rejectingPlayer is the would-be squad member
+            (Some(rejectingPlayer), Some(invitingPlayer))
+          case Some(BidForPosition(_, guid, _)) if idToSquad(guid).Leader.CharId != rejectingPlayer =>
+            //rejectingPlayer is the squad leader
+            (Some(rejectingPlayer), None)
+          case _ => ;
+            (None, None)
+        }) match {
+          case (Some(rejected), Some(invited)) =>
+            SquadEvents.publish( SquadServiceResponse(s"/$rejected/Squad", SquadResponse.Membership(SquadResponseType.Reject, 0, 0, rejected, Some(invited), "", true, Some(None))) )
+            SquadEvents.publish( SquadServiceResponse(s"/$invited/Squad", SquadResponse.Membership(SquadResponseType.Reject, 0, 0, invited, Some(rejected), tplayer.Name, false, Some(None))) )
+          case (Some(rejected), None) =>
+            SquadEvents.publish( SquadServiceResponse(s"/$rejected/Squad", SquadResponse.Membership(SquadResponseType.Reject, 0, 0, rejected, Some(rejected), "", true, Some(None))) )
+          case _ => ;
+        }
+        NextInvite(rejectingPlayer) match {
+          case Some(bid : BidForPosition) if rejectedBid.isEmpty || !rejectedBid.contains(bid) =>
+            HandleBidForPosition(bid, tplayer)
+          case Some(bid) if rejectedBid.isEmpty || !rejectedBid.contains(bid) =>
+            SquadEvents.publish(SquadServiceResponse(s"/$rejectingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Invite, 0, 0, bid.InviterCharId, Some(rejectingPlayer), bid.InviterName, false, Some(None))))
+          case None => ;
+        }
+
+      case SquadAction.Membership(SquadRequestType.Promote, promotingPlayer, Some(promotedPlayer), _, _) =>
+        (memberToSquad.get(promotingPlayer), memberToSquad.get(promotedPlayer)) match {
+          case (Some(squad), Some(squad2)) if squad.GUID == squad2.GUID && squad.Leader.CharId == promotingPlayer =>
+            val membership = squad.Membership.filter { _member => _member.CharId > 0 }
+            val (leader, position) = (squad.Leader, 0)
+            val (member, index) = membership.zipWithIndex.find { case (_member, _) => _member.CharId == promotedPlayer }.get
+            SwapMemberPosition(squad, leader, member)
+            log.info(s"Promoting player ${leader.Name} to be the leader of ${squad.Task}")
+            membership.foreach { _member =>
+              SquadEvents.publish(SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.PromoteMember(squad, promotedPlayer, index, position)))
+            }
+            SquadEvents.publish(SquadServiceResponse(s"/$promotingPlayer/Squad", SquadResponse.InitSquad(PlanetSideGUID(0))))
+            SquadEvents.publish(SquadServiceResponse(s"/$promotedPlayer/Squad", SquadResponse.InitSquad(squad.GUID)))
+            UpdateSquadListWhenListed(
+              squad,
+              SquadInfo().Leader(leader.Name)
+            )
+            UpdateSquadDetail(squad.GUID, squad,
+              SquadDetail()
+                .LeaderCharId(leader.CharId)
+                .Field3(value = 0L)
+                .LeaderName(leader.Name)
+                .Members(List(
+                  SquadPositionEntry(position, SquadPositionDetail().CharId(member.CharId).Name(member.Name)),
+                  SquadPositionEntry(index, SquadPositionDetail().CharId(leader.CharId).Name(leader.Name))
+                ))
+            )
+
+          case _ => ;
+        }
 
       case SquadAction.Update(char_id, health, max_health, armor, max_armor, pos, zone_number) =>
         memberToSquad.get(char_id) match {
